"""did_product

Revision ID: 037dfa489aef
Revises: 00fbe30a4cb0
Create Date: 2020-10-15 14:32:53.244264

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl
import imp,os

#alembic_helpers = imp.load_source('alembic_helpers', ( op.get_context().script.dir + '/alembic_helpers.py'))
#if not alembic_helpers.table_has_column('xxxx', 'yyyy'):



# revision identifiers, used by Alembic.
revision = '037dfa489aef'
down_revision = '00fbe30a4cb0'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('did_product',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=40), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('client_did_product',
    sa.Column('client_id', sa.Integer(), nullable=False),
    sa.Column('did_product_id', sa.Integer(), nullable=True),
    sa.Column('sms_rate_table_id', sa.Integer(), nullable=True),
    sa.Column('enable_sms', sa.Boolean(), server_default='false', nullable=True),
    sa.Column('created_by', sa.String(length=40), nullable=True),
    sa.Column('created_on', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.ForeignKeyConstraint(['client_id'], ['client.client_id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['did_product_id'], ['did_product.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['sms_rate_table_id'], ['rate_table.rate_table_id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('client_id')
    )
    op.create_table('did_product_item',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('did_product_id', sa.Integer(), nullable=True),
    sa.Column('country', sa.String(length=20), nullable=True),
    sa.Column('type', api_dnl.migration_types.ChoiceType({}), server_default='0', nullable=True),
    sa.Column('billing_rule_id', sa.Integer(), nullable=True),
    sa.Column('created_by', sa.String(length=40), nullable=True),
    sa.Column('created_on', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.ForeignKeyConstraint(['billing_rule_id'], ['did_billing_plan.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['country'], ['code_country.country_code'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['did_product_id'], ['did_product.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('did_product_item')
    op.drop_table('client_did_product')
    op.drop_table('did_product')
    # ### end Alembic commands ###
"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger IF EXISTS class4_trig_record_{table} on {table};
drop table IF EXISTS {table}_record;
DROP FUNCTION IF EXISTS class4_trigfun_record_{table}();
DROP SEQUENCE IF EXISTS {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))